#include <user_code.hpp>

// Display Componets
// Link with Dual state button object with id 2 on page 1 named bt0
NexButton row1_master = NexButton(1,11,"row1_master");
// List of Component ID Message to listen to
NexTouch *nex_listen_list[] =
    {
        &row1_master,
        NULL};

bool row1_is_on() {
    return pwm_get_state(LIGHT_THAW_NAH_THANG_KWAR) && pwm_get_state(LIGHT_THAW_NAH_THANG_SAI);
}

void row1_master_pop_callback(void *ptr)
{
    bool new_state = !row1_is_on();
    pwm_set_state(LIGHT_THAW_NAH_THANG_KWAR, new_state);
    pwm_set_state(LIGHT_THAW_NAH_THANG_SAI, new_state);

}

/*
This Code will run right after ESPMega PRO's
Peripheral Initialization Routine
*/
void user_pre_init()
{
    nexInit();
}

/*
This code will run after every component is initialized
*/
void user_init()
{
    elcd.print("page main");
    elcd_send_stop_bit();
    row1_master.attachPop(row1_master_pop_callback, &row1_master);
}

/*
This code will run once every event loop
*/
void user_loop()
{
    nexLoop(nex_listen_list);
}

/*
This code will run when an input pin changed state
*/
void virtual_interrupt_user_callback(int pin, int state)
{
}

void update_lcd_row1() {
    bool master_state = row1_is_on();
    //Assume 20 off, 21 on
    row1_master.Set_background_image_pic(master_state?21:20);
    bool lt1_state = pwm_get_state(LIGHT_THAW_NAH_THANG_KWAR);
    bool lt2_state = pwm_get_state(LIGHT_THAW_NAH_THANG_SAI);
    
}

void pwm_changed_user_callback(int pin)
{
    // switch (pin)
    // {
    // case LIGHT_THAW_NAH_THANG_KWAR:
    // case LIGHT_THAW_NAH_THANG_SAI:
    // update_lcd_row1();
    // break;
    
    // default:
    //     break;
    // }
}

/*
This code will run every 15 seconds
*/
void timer_tick_callback()
{
    if (standalone)
    {
    }
}

void ac_changed_user_callback(int mode, int temperature, int fan_speed) {
    
}

void mqtt_connected_user_callback() {

}

void user_state_request_callback() {

}

void user_mqtt_callback(char* topic, uint8_t topic_length, char* payload, unsigned int payload_length) {

}

void elcd_send_stop_bit() {
    elcd.write(0xFF);
    elcd.write(0xFF);
    elcd.write(0xFF);
}